Bug 507262

Summary: better fontconfig support with CMap
Product: [Fedora] Fedora Reporter: Takanori MATSUURA <t.matsuu>
Component: ghostscriptAssignee: David Kaspar [Dee'Kej] <dkaspar>
Status: ASSIGNED --- QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: low    
Version: rawhideCC: fonts-bugs, i18n-bugs, tagoh, twaugh
Target Milestone: ---Keywords: FutureFeature
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Attachments:
Description Flags
Universal CIDFnmap.ja
none
Universal FAPIcidfmap.ja
none
Universal cidfmap.ja
none
Suggesting cidfmap.ja.ipa none

Description Takanori MATSUURA 2009-06-21 22:27:44 EDT
I'm not sure which component should be assigned for this bug.  So I initially assign this bug to japanese-bitmap-fonts because the files for discussion is now owned by japanese-bitmap-fonts package.


Description of problem:
Now 
/usr/share/ghostscript/conf.d/CIDFnmap.ja
/usr/share/ghostscript/conf.d/FAPIcidfmap.ja
/usr/share/ghostscript/conf.d/cidfmap.ja
are owned by japanese-bitmap-fonts.  But they never use fonts which are bundled in japanese-bitmap-fonts.

Moreover, fonts which are set in the config files are dispersed among some packages.

So we need to separate ghostscript contig files from japanese-bitmap-fonts and they should be provided by another package (or included in ghostscript or ghostscript-fonts package).


I suggest the following idea.

1. Universal /usr/share/ghostscript/conf.d/{CIDFnmap.ja,FAPIcidfmap.ja,cidfmap.ja} is owned by new (eg. ghostscript-fonts-japanese), ghostscript, or ghostscript-fonts package.

2. Each Japanese fonts have their own CIDFnmap.ja, FAPIcidfmap.ja, and cidfmap.ja files i their common package.


Discussion required:
* fonts priority
* file owner for ghostscript config files
* package structure of IPA fonts are not ready for generate common subpackage now (bug 507261)
Comment 1 Takanori MATSUURA 2009-06-21 22:28:40 EDT
Created attachment 348838 [details]
Universal CIDFnmap.ja
Comment 2 Takanori MATSUURA 2009-06-21 22:29:17 EDT
Created attachment 348839 [details]
Universal FAPIcidfmap.ja
Comment 3 Takanori MATSUURA 2009-06-21 22:29:37 EDT
Created attachment 348840 [details]
Universal cidfmap.ja
Comment 4 Takanori MATSUURA 2009-06-21 22:30:36 EDT
Created attachment 348841 [details]
Suggesting cidfmap.ja.ipa
Comment 5 Akira TAGOH 2009-06-21 22:49:29 EDT
Thank you for bringing this up. this issue definitely needs to be fixed and is keeping alive in my todo queue..
Comment 6 Nicolas Mailhot 2009-06-22 02:28:38 EDT
BTW, the main problem seems to be ghostscript requires a separate set of
configuration files than the rest of the system. I suggest you focus on convincing the ghostscript people to use fontconfig like everyone else
to find fonts. That will fix any future problem of this kind.
Comment 7 Takanori MATSUURA 2009-06-22 05:18:27 EDT
I know ghostscript now supports fontconfig but I cannot find the document for setup.
Comment 8 Nicolas Mailhot 2009-06-22 14:04:26 EDT
(In reply to comment #7)
> I know ghostscript now supports fontconfig but I cannot find the document for
> setup.  

Well, if ghoscript now support font config we should certainly not add new cruft to its old font setup but on the contrary remove it and use fontconfig directly
Comment 9 Takanori MATSUURA 2009-06-22 20:27:50 EDT
(In reply to comment #8)
> Well, if ghoscript now support font config we should certainly not add new
> cruft to its old font setup but on the contrary remove it and use fontconfig
> directly  

Yes.  I absolutely agree with you.  When we can set config files for ghostscript with fontconfig support and it works fine, we should remove config files for ghostscript from font packages.

ghostscript-8.64 have "--disable-fontconfig" option for configure script and ghostscript on F11 is compiled with fontconfig.
Comment 10 Akira TAGOH 2009-06-22 21:23:56 EDT
(In reply to comment #8)
> (In reply to comment #7)
> > I know ghostscript now supports fontconfig but I cannot find the document for
> > setup.  
> 
> Well, if ghoscript now support font config we should certainly not add new
> cruft to its old font setup but on the contrary remove it and use fontconfig
> directly  

I'm afraid it may breaks some situations like PS requires the font with CMap. I see current gs supports fontconfig but it doesn't work as alternatives for them.

% gs
GPL Ghostscript 8.64 (2009-02-03)
Copyright (C) 2009 Artifex Software, Inc.  All rights reserved.
This software comes with NO WARRANTY: see the file PUBLIC for details.
GS>/IPAGothic-UniJIS-UTF8-H findfont
Can't find (or can't open) font file /usr/share/ghostscript/8.64/Resource/Font/IPAGothic-UniJIS-UTF8-H.
Can't find (or can't open) font file IPAGothic-UniJIS-UTF8-H.
Querying operating system for font files...
Can't find (or can't open) font file /usr/share/ghostscript/8.64/Resource/Font/IPAGothic-UniJIS-UTF8-H.
Can't find (or can't open) font file IPAGothic-UniJIS-UTF8-H.
Didn't find this font on the system!
Substituting font Courier for IPAGothic-UniJIS-UTF8-H.
Loading NimbusMonL-Regu font from /usr/share/fonts/default/Type1/n022003l.pfb... 3430216 1981599 7283800 5136677 1 done.
GS<1>clear
GS>/IPAGothic findfont
Loading IPAGothic font from /usr/share/fonts/ipa-gothic/ipag.otf... 3723064 2259574 13540108 11131402 1 done.
GS<1>

I don't think having aliases in fontconfig config for all of CMaps is realistic. it could be a bug in gs but we shouldn't go without fixing this issue.
Comment 11 Nicolas Mailhot 2009-06-23 02:15:51 EDT
I guess the bug then is that gs fontconfig support is incomplete
Comment 12 Takanori MATSUURA 2009-06-24 06:11:14 EDT
Change component from japanese-bitmap-fonts to ghostscript.
Comment 13 Bug Zapper 2010-04-27 11:08:51 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 14 Takanori MATSUURA 2011-02-03 04:11:56 EST
I've reverted component from ghostscript to japanese-bitmap-fonts.

CIDFnmap.ja, FAPIcidfmap.ja, and cidfmap.ja files have font lists which include only sazanami and vlgothic fonts. However those fonts are provided by another packages.

I suggest those *.ja files should be separated to another package.
ie. ghostscript-chinese


And I hope the default Japanese fonts for ghostscript will be set to IPA fonts. :-)
IPA fonts are higher quality than sazanami fonts and includes both mincho and gothic fonts under the same design policy.
Comment 15 Akira TAGOH 2011-02-03 04:38:40 EST
I thought the direction of the past discussion was to get rid of those extra configuration files, relying on fontconfig completely to get the better fonts. so that would be better filing a separate bug for a workaround. assigning back to ghostscript.

Aside from that, having different fonts for displaying and printing isn't a good idea from the POV of WYSIWYG IMHO.
Comment 16 Fedora Admin XMLRPC Client 2015-04-22 07:00:32 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 17 Fedora Admin XMLRPC Client 2015-08-03 07:59:26 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.